#!/vol/PACK/perl5.004_04/bin/perl -w
#
# ConnLog.pm
#
# Logging for ConnDB system
#
# Andrew.Findlay@brunel.ac.uk
# August 1999
#
# @(#) ConnLog.pm 1.4@(#)

########################################################################
# Boilerplate stuff to make this into a perl module
########################################################################
package ConnLog;

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(
	Log
	LogUser
	LogFileName
);
########################################################################
########################################################################

use strict;
use FileHandle;
use Date::Manip;

my ($LogFH);

my ($LogFileName) = "/tmp/conn.log";
my ($User) = "UNKNOWN";

########################################################################
# Set name of file to log into (must be called before Log is used)
########################################################################
sub LogFileName {
	($LogFileName) = @_;
}

########################################################################
# Set name of logged-in user (must be called before Log is used)
########################################################################
sub LogUser {
	($User) = @_;
}

########################################################################
# Log a message
########################################################################
sub Log {
	my ($severity, $message) = @_;

	# Open the log file if necessary
	if (!defined($LogFH)) {
		# We need to open the log file
		$LogFH = new FileHandle $LogFileName, ">>";
		if (!defined($LogFH)) {
			die "Cannot open logfile $LogFileName";
		}

		# Set it to auto-flush buffers
		$LogFH->autoflush(1);
	}

	my ($timestamp) = UnixDate( "today", "%Y-%m-%d %H:%M:%S" );

	# Log the message
	printf $LogFH "$timestamp $severity $User $message\n";
}

########################################################################
#
# Mark end of ConnLog.pm with true return
#
########################################################################

1;

########################################################################
########################################################################
########################################################################
