#!/vol/PACK/perl5.004_04/bin/perl -w
#
# TestConnDB.pl
#
# Andrew.Findlay@brunel.ac.uk
# August 1999
#
# %A%


use strict;
use DBI;
use ConnDB;
use ConnWeb;
use ConnLog;

# We want this script to run in Taint mode so clean up the PATH
$ENV{PATH} = "/usr/ucb:/usr/bin";
 
# Use templates in the source-code area when testing
SetHTMLDir( "/usr/src/local/NET/connections/html" );

# Use a non-active database when testing
SetDBParamFile( "/usr/src/local/NET/connections/dbsetup/example_params_file" );
 
# Testing version of CGI URL
SetCgiUrl( "http://www.brunel.ac.uk/cgi/connections/conntest.cgi" );
 
# Log to temporary area when testing
LogFileName( "/tmp/conntest.log" );
 
# Bypass webserver authentication for testing without a webserver
SetAllowFudgeUser(1);
 
# Use different page style to make clear that this is a test
SetTestMode(1);
 
# Save queries to a logfile if this is set to a filename.
# Dont save if set to zero
SetSaveQueries(0);
 



if (Connect("/usr/src/local/NET/connections/dbsetup/example_params_file")) {
	die "Connect failed $ConnDB::errstr";
}

if (0) {
	print "Testing FetchFullName(em98ikb, 1)\n";
	my($name) = FetchFullName("em98ikb", 1);
	if ($name) {
		print "OK: got $name\n";
	}
	else {
		die "FetchFullName failed $ConnDB::errstr";
	}
}

if (0) {
	print "Testing FetchFullName(ccdemo10, 0)\n";
	my($name) = FetchFullName("ccdemo10", 0);
	if ($name) {
		print "OK: got $name\n";
	}
	else {
		die "FetchFullName failed $ConnDB::errstr";
	}
}

if (0) {
	print "Testing AddUser\n";
	if (!AddUser("ccdemo19")) {
		die "AddUser failed $ConnDB::errstr";
	}
}

if (0) {
	print "Testing HasBlocks(1)\n";
	my ($result) = HasBlocks(1);
	print "result $result\n";

	print "Testing HasBlocks(7)\n";
	$result = HasBlocks(7);
	print "result $result\n";

	print "Testing HasBlocks(-1)\n";
	$result = HasBlocks(-1);
	print "result $result\n";
}

if (0) {
	print "Testing FetchDeviceList(1,2)\n";
	my ($result) = FetchDeviceList(1,2);
	if (!$result) {
		die "FetchDeviceList failed $ConnDB::errstr";
	}
	my ($item);
	for ($item=0;defined($result->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($result->[$item][$field]);$field++) {
			print $result->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing AddCardDetails\n";

	my ($bill_id);

	if ($bill_id=AddCardDetails(
		"Mr R Stephenson",
		"9876 1234 5678 6785",
		"03/79",
		""
	)) {
		print "Request ID is $bill_id\n";
	} else {
		die "AddCardDetails failed $ConnDB::errstr";
	}

	print "Testing AddServiceRequest\n";

	my ($srvreqid);

	if ($srvreqid=AddServiceRequest(
			"me87rjs",
			1,
			45,
			$bill_id,
			"")) {
		print "Service Request ID is $srvreqid\n";
	} else {
		die "AddServiceRequest failed $ConnDB::errstr";
	}

	print "Testing AddServiceRequestItem\n";
	if (AddServiceRequestItem(
			$srvreqid,
			1,
			1,
			17,
			35,
			"10M",
			"1997-01-01",
			"1999-12-31",
			1,
			"")) {
		print "Added item\n";
	} else {
		die "AddServiceRequestItem failed $ConnDB::errstr";
	}
}

if (0) {
	my ($srvreqid);

	if ($srvreqid=AddServiceRequest(
			"lw97abc",
			1,
			45,
			0,
			"")) {
		print "Service Request ID is $srvreqid\n";
	} else {
		die "AddServiceRequest failed $ConnDB::errstr";
	}

	print "Testing AddServiceRequestItem\n";
	if (AddServiceRequestItem(
			$srvreqid,
			1,
			1,
			"17",
			"99",
			"10M",
			"1997-01-01",
			"1999-12-31",
			1,
			"")) {
		print "Added item\n";
	} else {
		die "AddServiceRequestItem failed $ConnDB::errstr";
	}
}

if (0) {
	print "Testing AddConnection\n";
	if (!AddConnection( 7,"","870","356",4,"5",47,"operator")) {
		die "AddConnection failed $ConnDB::errstr";
	}
}

if (0) {
	print "Testing FetchBuildingList\n";
	my ($reqs) = FetchBuildingList( 2 );
	if (!$reqs) {
		die "FetchBuildingList failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}


if (0) {
	print "Testing FetchSemesterList\n";
	my ($reqs) = FetchSemesterList( 2 );
	if (!$reqs) {
		die "FetchSemesterList failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing FetchBillingDetails\n";
	my (@reqs) = FetchBillingDetails( 0 );
	if (!@reqs) {
		die "FetchBillingDetails failed $ConnDB::errstr";
	}
	
	my ($field);
	for ($field=0;defined($reqs[$field]);$field++) {
		print $reqs[$field];
		print "|";
	}
	print "\n";
}

if (0) {
	print "Testing FetchRequests( em98ikb, % )\n";
	my ($reqs) = FetchRequests( "em98ikb", "%" );
	if (!$reqs) {
		die "FetchRequests failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}


if (1) {
	print "Testing FetchRequests( %, 40 )\n";
	my ($reqs) = FetchRequests( "%", 40 );
	if (!$reqs) {
		die "FetchRequests failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing FetchRequestItemsByRequestID\n";
	my ($reqs) = FetchRequestItemsByRequestID( 31 );
	if (!$reqs) {
		die "FetchRequestItemsByRequestID failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}


if (0) {
	print "Testing FetchLatePayments\n";
	my ($reqs) = FetchLatePayments(7);
	if (!$reqs) {
		die "FetchLatePayments failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing FetchPendingCardPayments\n";
	my ($reqs) = FetchPendingCardPayments();
	if (!$reqs) {
		die "FetchPendingCardPayments failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing FetchPendingCashPayments\n";
	my ($reqs) = FetchPendingCashPayments();
	if (!$reqs) {
		die "FetchPendingCashPayments failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing FetchPendingConnections\n";
	my ($reqs) = FetchPendingConnections("%","%");
	if (!$reqs) {
		die "FetchPendingConnections failed $ConnDB::errstr";
	}
	
	my ($item);
	for ($item=0;defined($reqs->[$item]);$item++) {
		my ($field);
		for ($field=0;defined($reqs->[$item][$field]);$field++) {
			print $reqs->[$item][$field];
			print "|";
		}
		print "\n";
	}
}

if (0) {
	print "Testing ProcessPrePayment\n";
	if (ProcessPrePayment(36,134.00))
	{
		print "OK\n";
	}
	else {
		die "FetchPendingConnections failed $ConnDB::errstr";
	}
	
}


if (0) {
	print "Testing KnownOutletNumber\n";
	if (KnownOutletNumber(6,1,14))
	{
		print "6,1,14 known\n";
	}
	else {
		print "6,1,14 not known\n";
	}
	if (KnownOutletNumber(1,1,14))
	{
		print "1,1,14 known\n";
	}
	else {
		print "1,1,14 not known\n";
	}
	
}

if (1) {
	print "Testing GetCounts\n";
	my ($s) = GetCounts;
	print "$s\n";
}
