#!/vol/PACK/perl5.004_04/bin/perl -w
#
# mail-expiry-reminders
#
# Andrew.Findlay@brunel.ac.uk
# January 2000
#
# @(#) mail-expiry-reminders.pl 1.2@(#)

use lib "/vol/PACK/connections/lib";

use strict;
use ConnDB;
use ConnLog;
use HTML::Template;
use Mail::Send;

# We want this script to run in Taint mode so clean up the PATH
$ENV{PATH} = "/usr/ucb:/usr/bin";

# Who should the mail appear to be from?
my ($MailFrom) = "networks (Networks Group)";

# Template directory
my ($templatedir) = "/vol/PACK/connections/html";
#my ($templatedir) = "/usr/src/local/NET/connections/html";

# Params for the active database
my ($DBParamFile) = "/vol/PACK/connections/etc/db-params";
#my ($DBParamFile) = "/usr/src/local/NET/connections/dbsetup/example_params_file";

# Log all events to file
LogFileName( "/vol/PACK/connections/log/connections" );
#LogFileName( "/tmp/connections" );

# How far ahead should we send reminders?
my ($CONST_days_ahead) = 30;

########################################################################
# Send a mail message: SendMail( <to>, <subject>, <message> )
########################################################################
sub SendMail {
	my ($to, $subject, $text) = @_;

	my ($msg) = new Mail::Send;
	$msg->to($to);
	$msg->subject($subject);
	$msg->set('From', $MailFrom);

	# We must use Sendmail transport to be able to set 'From'
	my ($fh) = $msg->open('sendmail');

	print $fh $text;
	$fh->close;
}


########################################################################
# Mail reminders to people whose connections will soon expire
########################################################################
sub MailExpiryReminders {
	my ($template) = HTML::Template->new(
		filename => "$templatedir/expiry-reminder-mail.txt" );

	my ($list_items) = FetchExpiringConnections( $CONST_days_ahead );;
	if (!$list_items) {
		EmitError( "FetchExpiringConnections failed $ConnDB::errstr" );
		return 0;
	}

	# Unpick the array of arrays send mail for each item
	my ($item);
	for ($item=0;defined($list_items->[$item]);$item++) {
		# print "Reminder to $list_items->[$item][0]\n";

		$template->param( "username" => $list_items->[$item][0] );
		$template->param( "fullname" => $list_items->[$item][1] );
		$template->param( "end_date" => $list_items->[$item][2] );
		$template->param( "building" => $list_items->[$item][3] );
		$template->param( "block" => $list_items->[$item][4] );
		$template->param( "room" => $list_items->[$item][5] );
		$template->param( "outlet" => $list_items->[$item][6] );

		SendMail( $list_items->[$item][0],
			"Halls Network Service expiring soon",
			$template->output() );

		# Rate-limit this to avoid clogging the machine with mail
		sleep (1);
	}

}

# Wind up the database
if (Connect($DBParamFile)) {
	die "Connect failed $ConnDB::errstr";
}

MailExpiryReminders;


