#!/vol/PACK/perl5.004_04/bin/perl -w
#
# mail-reminders
#
# Andrew.Findlay@brunel.ac.uk
# August 1999
#
# @(#) mail-reminders.pl 1.3@(#)

use lib "/vol/PACK/connections/lib";

use strict;
use ConnDB;
use ConnLog;
use HTML::Template;
use Mail::Send;

# We want this script to run in Taint mode so clean up the PATH
$ENV{PATH} = "/usr/ucb:/usr/bin";

# Who should the mail appear to be from?
my ($MailFrom) = "networks (Networks Group)";

# Template directory
my ($templatedir) = "/vol/PACK/connections/html";

# Params for the active database
my ($DBParamFile) = "/vol/PACK/connections/etc/db-params";
#my ($DBParamFile) = "/usr/src/local/NET/connections/dbsetup/example_params_file";

# Log all events to file
LogFileName( "/vol/PACK/connections/log/connections" );

# How late should the payment be to warrant a reminder?
my ($CONST_days_late) = 10;

########################################################################
# Send a mail message: SendMail( <to>, <subject>, <message> )
########################################################################
sub SendMail {
	my ($to, $subject, $text) = @_;

	my ($msg) = new Mail::Send;
	$msg->to($to);
	$msg->subject($subject);
	$msg->set('From', $MailFrom);

	# We must use Sendmail transport to be able to set 'From'
	my ($fh) = $msg->open('sendmail');

	print $fh $text;
	$fh->close;
}


########################################################################
# Mail reminders to people who have applied for service but not paid
########################################################################
sub MailLatePaymentReminders {
	my ($template) = HTML::Template->new(
		filename => "$templatedir/payment-reminder-mail.txt" );

	my ($list_items) = FetchLatePayments( $CONST_days_late );;
	if (!$list_items) {
		EmitError( "FetchLatePayments failed $ConnDB::errstr" );
		return 0;
	}

	# Unpick the array of arrays send mail for each item
	my ($item);
	for ($item=0;defined($list_items->[$item]);$item++) {
		$template->param( "username" => $list_items->[$item][1] );
		$template->param( "fullname" => $list_items->[$item][2] );
		my ($datetime) = $list_items->[$item][3];
		$datetime =~ s/ / at /;
		$template->param( "req_date" => $datetime );
		$template->param( "charge" => $list_items->[$item][4] );

		SendMail( $list_items->[$item][1],
			"Payment for Halls Network Service",
			$template->output() );
	}

}

# Wind up the database
if (Connect($DBParamFile)) {
	die "Connect failed $ConnDB::errstr";
}

MailLatePaymentReminders;


