#!/vol/PACK/perl5.004_04/bin/perl -w
#
# make-halls-mailing-list.pl
#
# Updates mailing list of active Halls Network users
#
# Andrew.Findlay@brunel.ac.uk
# August 1999
#
# @(#) make-halls-mailing-list.pl 1.1@(#)

use lib "/vol/PACK/connections/lib";
#use lib "/usr/src/local/NET/connections/src";

use strict;
use ConnDB;
use ConnLog;

# We want this script to run in Taint mode so clean up the PATH
$ENV{PATH} = "/usr/ucb:/usr/bin";

# Location of mailing-list file
my ($ListFile) = "/vol/PACK/pp/lists/halls-pc";
# my ($ListFile) = "/tmp/halls-pc";

# Params for the active database
my ($DBParamFile) = "/vol/PACK/connections/etc/db-params";
#my ($DBParamFile) = "/usr/src/local/NET/connections/dbsetup/example_params_file";

# Log all events to file
LogFileName( "/vol/PACK/connections/log/connections" );
#LogFileName( "/tmp/connections" );


########################################################################
# Mail reminders to people who have applied for service but not paid
########################################################################
sub UpdateMailingList {

	# Get current list members
	open LISTFILE, $ListFile or die "Cannot read $ListFile";

	my (@PermanentMembers);
	my ($index) = 0;

	while (<LISTFILE>) {
		# We only want to remember non-students
		chomp;
		next if /^..[0-9][0-9]/;
		next if /^..pg/;
		# print "Keeping $_\n";
		$PermanentMembers[$index++] = $_;
	}
	close LISTFILE;

	# Get list of current Halls users from database
	my ($list_items) = FetchActiveUserList();
	if (!$list_items) {
		die( "FetchActiveUserList failed $ConnDB::errstr" );
	}

	# OK - we have all the data we need to rebuild the list

	# Truncate the existing file
	open LISTFILE, ">$ListFile" or die "Cannot write to $ListFile";

	# Put back the permanent members
	$index = 0;
	while (defined($PermanentMembers[$index])) {
		print LISTFILE "$PermanentMembers[$index++]\n";
	}

	# Unpick the array of arrays - we only want the first field of each
	# Add usernames to the mailing list
	my ($item);
	for ($item=0;defined($list_items->[$item]);$item++) {
		my ($username) = $list_items->[$item][0];
		print LISTFILE "$username\n";
	}

	close LISTFILE or die "Error closing $ListFile after writing";

	return 0;
}

# Wind up the database
if (Connect($DBParamFile)) {
	die "Connect failed $ConnDB::errstr";
}

UpdateMailingList;


